﻿Imports System.Data.SqlClient
Public Class Form1
    Dim s As String = "app=hamedkhan;Server=.;Database=mysale;Trusted_Connection=True;"
    Private Sub SqlEvent1(ByVal sender As Object, ByVal e As SqlInfoMessageEventArgs)
        MsgBox(e.Message, MsgBoxStyle.Critical, e.Errors(0).Number)
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim db As New Mydb(s, True)
        AddHandler db.sqlInfoMessage, AddressOf SqlEvent1
        Try
            db.RunSQL("INSERT INTO Orders(CID, GID, GCount )VALUES(2,1,2)")
        Catch ex As SqlException
            MsgBox(ex.Errors(1).Number)
        End Try
    End Sub
End Class
Public Class Mydb
    Private CNNString As String = ""
    Private CNN As SqlConnection
    Private AutoOC As Boolean = False
    Public Event sqlInfoMessage As sqlInfoMessageEventHandler
    Private Sub _New(ByVal dbConnectionString As String, ByVal AutoOpenClose As Boolean)
        CNN = New SqlConnection(dbConnectionString)
        CNNString = dbConnectionString

        AutoOC = AutoOpenClose

        AddHandler CNN.InfoMessage, New SqlInfoMessageEventHandler(AddressOf SqlEvent)
        AddHandler CNN.StateChange, New StateChangeEventHandler(AddressOf CnnChangeState)
    End Sub
    Public Sub New(ByVal dbConnectionString As String, ByVal AutoOpenClose As Boolean)
        _New(dbConnectionString, AutoOpenClose)
    End Sub
    Public Sub New(ByVal dbConnectionString As String)
        _New(dbConnectionString, False)
    End Sub
    Public Sub Open()
        If CNN.State <> ConnectionState.Open Then CNN.Open()
    End Sub
    Public Sub Close()
        If CNN.State = ConnectionState.Open Then CNN.Close()
    End Sub
    Public ReadOnly Property GetConnection As SqlConnection
        Get
            Return CNN
        End Get
    End Property
    Public ReadOnly Property GetConnectionString As String
        Get
            Return CNNString
        End Get
    End Property

    Public Function RunSQL(ByVal sql As String) As Integer
        Dim Result As Integer = 0
        If AutoOC Then Open()
        Dim CMD As New SqlCommand
        If Not CNN.State = ConnectionState.Open Then
            Throw (New Exception("Connection is closed"))
        End If
        Try
            CMD.CommandText = sql
            CMD.Connection = CNN
            Return (CMD.ExecuteNonQuery())
        Catch ex As SqlException
            Throw (ex)
        End Try
        If AutoOC Then Close()
        Return Result
    End Function

    Public Function SelectTable(ByVal sql As String) As DataTable
        Dim Result As New DataTable
        If AutoOC Then Open()
        If Not CNN.State = ConnectionState.Open Then
            Throw (New Exception("Connection is closed"))
        End If
        Try
            Dim myAdaptor As SqlDataAdapter
            myAdaptor = New SqlDataAdapter(New SqlCommand(sql, CNN))
            myAdaptor.SelectCommand.CommandType = CommandType.StoredProcedure
            myAdaptor.Fill(Result)
            Result.TableName = "Arfaeih"
        Catch ex As SqlException
            Throw (ex)
        End Try
        If AutoOC Then Close()
        Return Result
    End Function

    Public Function SelectSP(ByVal spName As String, ByVal ParamArray myData() As MyFields) As DataSet
        Dim Result As New DataSet
        If AutoOC Then Open()
        If Not CNN.State = ConnectionState.Open Then
            Throw (New Exception("Connection is closed"))
        End If
        Try
            Dim myAdaptor As SqlDataAdapter
            myAdaptor = New SqlDataAdapter(New SqlCommand(spName, CNN))
            myAdaptor.SelectCommand.CommandType = CommandType.StoredProcedure
            If Not IsNothing(myData) Then
                Dim tmpFields As New MyFields
                For I As Integer = 0 To UBound(myData)
                    tmpFields.Combine(myData(I).Getlist)
                Next I
                For Each mst As MyFields.Mystruct In tmpFields.Getlist
                    myAdaptor.SelectCommand.Parameters.AddWithValue(mst.MyField, mst.MyValue)
                Next
            End If
            myAdaptor.Fill(Result)
        Catch ex As SqlException
            Throw (ex)
        End Try
        If AutoOC Then Close()
        Return Result
    End Function
    Public Function SelectSP(ByVal spName As String) As DataSet
        Return SelectSP(spName, Nothing)
    End Function

    Private Sub CnnChangeState(ByVal sender As Object, ByVal e As StateChangeEventArgs)

    End Sub
    Private Sub SqlEvent(ByVal sender As Object, ByVal e As SqlInfoMessageEventArgs)
        RaiseEvent sqlInfoMessage(sender, e)
    End Sub
    Public Sub dispose()
        CNN.Dispose()
        GC.Collect()
    End Sub
End Class
Public Class MyFields
    Public Structure Mystruct
        Dim MyField As String
        Dim MyValue As Object
    End Structure
    Dim Allfields As New ArrayList
    Public Sub Clear()
        Allfields.Clear()
    End Sub
    Public Sub New()

    End Sub
    Public Sub New(ByVal myFname As String, ByVal myVal As Object)
        Add(myFname, myVal)
    End Sub
    Public Sub Add(ByVal myFname As String, ByVal myVal As Object)
        Dim NewStruct As New Mystruct
        NewStruct.MyField = myFname
        NewStruct.MyValue = myVal
        Allfields.Add(NewStruct)
        NewStruct = Nothing
    End Sub
    Public Sub Combine(ByVal newArray As ArrayList)
        For Each mst As MyFields.Mystruct In newArray
            Allfields.Add(mst)
        Next
    End Sub
    Public Function Getlist() As ArrayList
        Return Allfields
    End Function
End Class